<template>
  <div class="d-flex justify-content-center">
    <h2 class="m-3">Meine Tickets ({{tickets.length}})</h2>
  </div>
  <table class="table table-bordered table-hover text-center">
    <thead>
    <tr>
      <th>Titel</th>
      <th>Beschreibung</th>
      <th>Erstellt</th>
      <th>Priorität</th>
      <th>Status</th>
      <th>Abteilung</th>
      <th>Aktionen</th>
    </tr>
    </thead>
    <tbody>
    <ticket-data
        v-for="ticket in tickets"
        :ticket="ticket"
        :page="currentPage"
    ></ticket-data>
    </tbody>
    <tr>
      <td colspan="3">
        <v-btn
            color="blue-darken-4"
            @click="prevPage"
            :disabled="currentPage === 1"><v-icon>mdi-arrow-left-drop-circle-outline</v-icon></v-btn>
      </td>
      <td colspan="2">
        <p class="border-light-subtle mt-2 text-center">Seite: {{currentPage}}</p>
      </td>
      <td colspan="3">
        <v-btn
            color="blue-darken-4"
            :disabled="tickets.length < 10"
            @click="nextPage"><v-icon>mdi-arrow-right-drop-circle-outline</v-icon></v-btn>
      </td>
    </tr>
  </table>
</template>

<script setup>

import {useTicketStore} from "@/stores/ticketStore";
import {computed, onMounted, ref} from "vue";
import TicketData from "@/components/TicketData.vue";
import {useAuthStore} from "@/stores/authStore";

//STORES
const ticketStore = useTicketStore();
const authStore = useAuthStore();

//VARIABLES
const tickets = computed(() => {
  return ticketStore.tickets.filter(ticket => ticket.resolvedBy === authStore.user.username
      || ticket.resolvedBy === authStore.user.userId);
})
const currentPage = ref(1);

//FUNCTIONS
async function fetchTickets(page) {
  await ticketStore.getTickets(page);
}

function nextPage() {
  currentPage.value++;
  fetchTickets(currentPage.value);
}

function prevPage() {
  if (currentPage.value > 0) {
    currentPage.value--;
    fetchTickets(currentPage.value);
  }
}

//LIFECYCLEHOOK
onMounted(async () => {
  await fetchTickets(currentPage.value);
});
</script>

<style scoped>

</style>